from .utils.JsonMap import JsonMap
from .base import BaseModel


@JsonMap({})
class CreateAddressRequest(BaseModel):
    def __init__(
        self,
        line_1: str,
        name: str,
        canton: str = None,
        city: str = None,
        country: str = None,
        district: str = None,
        line_2: str = None,
        line_3: str = None,
        metadata: dict = None,
        phone_number: str = None,
        state: str = None,
        zip: str = None,
    ):
        self.canton = canton
        self.city = city
        self.country = (
            self._pattern_matching(
                country,
                "^(A(D|E|F|G|I|L|M|N|O|R|S|T|Q|U|W|X|Z)|B(A|B|D|E|F|G|H|I|J|L|M|N|O|R|S|T|V|W|Y|Z)|C(A|C|D|F|G|H|I|K|L|M|N|O|R|U|V|X|Y|Z)|D(E|J|K|M|O|Z)|E(C|E|G|H|R|S|T)|F(I|J|K|M|O|R)|G(A|B|D|E|F|G|H|I|L|M|N|P|Q|R|S|T|U|W|Y)|H(K|M|N|R|T|U)|I(D|E|Q|L|M|N|O|R|S|T)|J(E|M|O|P)|K(E|G|H|I|M|N|P|R|W|Y|Z)|L(A|B|C|I|K|R|S|T|U|V|Y)|M(A|C|D|E|F|G|H|K|L|M|N|O|Q|P|R|S|T|U|V|W|X|Y|Z)|N(A|C|E|F|G|I|L|O|P|R|U|Z)|OM|P(A|E|F|G|H|K|L|M|N|R|S|T|W|Y)|QA|R(E|O|S|U|W)|S(A|B|C|D|E|G|H|I|J|K|L|M|N|O|R|T|V|Y|Z)|T(C|D|F|G|H|J|K|L|M|N|O|R|T|V|W|Z)|U(A|G|M|S|Y|Z)|V(A|C|E|G|I|N|U)|W(F|S)|Y(E|T)|Z(A|M|W))$",
                "country",
            )
            if country
            else None
        )
        self.district = district
        self.line_1 = line_1
        self.line_2 = line_2
        self.line_3 = line_3
        self.metadata = metadata
        self.name = name
        self.phone_number = phone_number
        self.state = state
        self.zip = zip
